/********************************************************
 *  ██████╗  ██████╗████████╗██╗
 * ██╔════╝ ██╔════╝╚══██╔══╝██║
 * ██║  ███╗██║        ██║   ██║
 * ██║   ██║██║        ██║   ██║
 * ╚██████╔╝╚██████╗   ██║   ███████╗
 *  ╚═════╝  ╚═════╝   ╚═╝   ╚══════╝
 * Geophysical Computational Tools & Library (GCTL)
 *
 * Copyright (c) 2022  Yi Zhang (yizhang-geo@zju.edu.cn)
 *
 * GCTL is distributed under a dual licensing scheme. You can redistribute 
 * it and/or modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either version 2 
 * of the License, or (at your option) any later version. You should have 
 * received a copy of the GNU Lesser General Public License along with this 
 * program. If not, see <http://www.gnu.org/licenses/>.
 * 
 * If the terms and conditions of the LGPL v.2. would prevent you from using 
 * the GCTL, please consider the option to obtain a commercial license for a 
 * fee. These licenses are offered by the GCTL's original author. As a rule, 
 * licenses are provided "as-is", unlimited in time for a one time fee. Please 
 * send corresponding requests to: yizhang-geo@zju.edu.cn. Please do not forget 
 * to include some description of your company and the realm of its activities. 
 * Also add information on how to contact you by electronic and paper mail.
 ******************************************************/

#include "../lib/seismic.h"

int main(int argc, char const *argv[]) try
{
    //gctl::UTC_TIME t(2001, 2, 29, 23, 59, 58, 224);
    /*
    gctl::UTC_TIME t("2000-2-29T23:59:58.124");
    std::cout << t.time_str(true) << "\n";
    std::cout << t.time_str() << "\n";
    std::cout << t.rdseed_time_str() << "\n";

    t.add_duration(3600*24);
    std::cout << t.time_str() << "\n";

    t.round_up_to(gctl::Day);
    std::cout << t.time_str() << "\n";

    gctl::UTC_TIME t2 = t;

    t.add_duration(120.00050001);
    t2.add_duration(120.00049999);
    std::cout << t.time_str() << "\n";
    std::cout << t2.time_str() << "\n";

    t.set_to_now();
    std::cout << t.time_str() << "\n";
    */
    gctl::UTC_TIME t1, t2;
    t1.set_time("2021-1-1T14:04:14.591");
    t2.set_time("2021-1-1T14:02:14.590");
    if (t1 <= t2) std::cout << "t1 <= t2\n";
    else std::cout << "t1 > t2\n";
    return 0;
}
catch(std::exception &e)
{
    GCTL_ShowWhatError(e.what(), GCTL_ERROR_ERROR, 0, 0, 0);
}